<template>
  <Layout>
    <div class="contenedor-empleados">
      <div class="agregar-empleado">
        <button
          type="button"
          class="btn btn-primary"
          data-bs-toggle="modal"
          data-bs-target="#newEmployee"
        >
          Nuevo empleado
        </button>
      </div>
      <div class="filtro">
        <form class="d-flex" id="formBuscaxrEmpleado" role="search">
          <input
            class="form-control me-2"
            type="search"
            id="buscarEmpleado"
            placeholder="Nombre de empleado"
            v-model="busqueda"
            aria-label="Search"
          />
          <button class="btn btn-outline-primary" type="button" @click="getEmployees">
            Buscar
          </button>
        </form>
      </div>
      <div class="listado-empleados">
        <table class="table table-striped table-hover">
          <thead>
            <tr>
              <th scope="col">No empleado</th>
              <th scope="col">Nombre</th>
              <th scope="col">Rol</th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="empleado in listadoEmpleados"
              :key="empleado.noEmployee"
              @click="showEditar(empleado.id)"
              data-bs-toggle="modal"
              data-bs-target="#updateEmployee"
            >
              <th scope="row">{{ empleado.noemployee }}</th>
              <td>{{ empleado.name }}</td>
              <td>{{ empleado.description }}</td>
            </tr>
          </tbody>
        </table>
        <div v-if="listadoEmpleados.length < 1" class="sin-contenido">
          <p class="sin-info">
            No se han encontrado resultados en la búsqueda, por favor vuelva a intentarlo.
          </p>
        </div>
      </div>
    </div>

    <Modal
      titulo="Nuevo empleado"
      textButtonSave="Guardar"
      textButtonClose="Cerrar"
      identificador="newEmployee"
      @clickGuardar="saveEmployee"
    >
      <form class="form-floating login-form">
        <div class="form-floating mb-3">
          <input
            type="number"
            class="form-control"
            placeholder="Número de empleado"
            id="noEmpleado"
            v-model="noEmpleado"
            required
            @keyup="cleanError"
          />
          <label for="noEmpleado">Número de empleado</label>
        </div>
        <div class="form-floating mb-3">
          <input
            type="text"
            class="form-control rounded-left"
            placeholder="Contraseña"
            id="nombreEmpleado"
            v-model="nombreEmpleado"
            required
            @keyup="cleanError"
          />
          <label for="nombreEmpleado">Nombre</label>
        </div>
        <div class="form-floating mb-3">
          <select
            type="text"
            class="form-select rounded-left"
            placeholder="Contraseña"
            id="rolEmpleado"
            v-model="rolEmpleado"
            required
            @change="cleanError"
          >
            <option :value="null">Selecciona una opción</option>
            <option :value="rol.id" v-for="rol in listaRoles" :key="rol.id">
              {{ rol.description }}
            </option>
          </select>
          <label for="rolEmpleado">Rol</label>
        </div>
      </form>
      <div class="contenedor-error" v-if="apiError != ''">
        {{ apiError }}
      </div>
    </Modal>

    <Modal
      titulo="Editar empleado"
      textButtonSave="Editar"
      textButtonClose="Cerrar"
      identificador="updateEmployee"
      identificadorCerrar="cerrarEditar"
      @clickGuardar="updateEmployee"
    >
      <form class="form-floating login-form">
        <div class="form-floating mb-3">
          <input
            type="number"
            class="form-control"
            placeholder="Número de empleado"
            id="noEmpleado"
            v-model="noEmpleadoEdit"
            required
            @keyup="cleanError"
          />
          <label for="noEmpleado">Número de empleado</label>
        </div>
        <div class="form-floating mb-3">
          <input
            type="text"
            class="form-control rounded-left"
            placeholder="Contraseña"
            id="nombreEmpleado"
            v-model="nombreEmpleadoEdit"
            required
            @keyup="cleanError"
          />
          <label for="nombreEmpleado">Nombre</label>
        </div>
        <div class="form-floating mb-3">
          <select
            type="text"
            class="form-select rounded-left"
            placeholder="Contraseña"
            id="rolEmpleado"
            v-model="rolEmpleadoEdit"
            required
            @change="cleanError"
          >
            <option :value="null">Selecciona una opción</option>
            <option :value="rol.id" v-for="rol in listaRoles" :key="rol.id">
              {{ rol.description }}
            </option>
          </select>
          <label for="rolEmpleado">Rol</label>
        </div>
      </form>
      <div class="contenedor-error" v-if="apiError != ''">
        {{ apiError }}
      </div>
    </Modal>

    <Modal
      v-if="tokenExpired"
      titulo="Cierre de sesion"
      textButtonSave="Cerrar sesion"
      :showButtonClose="false"
      @clickGuardar="logOut"
      identificador="sessionExpired"
      :hidden="false"
    >
      <p>Estimado usuario, tu sesion ha expirado.</p>
    </Modal>
  </Layout>
</template>

<script>
import Layout from '../layouts/Layout.vue'
import Modal from '../components/Modal.vue'
import serviceEmployees from '../services/employees'
import serviceRoles from '../services/roles'
import { useSesionUsuario } from '../stores/user'

export default {
  name: 'Employees',
  components: {
    Layout,
    Modal
  },
  data() {
    return {
      listadoEmpleados: [],
      noEmpleado: '',
      nombreEmpleado: '',
      rolEmpleado: null,
      listaRoles: [],
      busqueda: null,
      apiError: '',
      idEmpleado: null,
      noEmpleadoEdit: '',
      nombreEmpleadoEdit: '',
      rolEmpleadoEdit: null,
      tokenExpired: false
    }
  },
  beforeMount() {
    this.getEmployees()
    this.getRoles()
  },
  methods: {
    async getEmployees() {
      try {
        const response = await serviceEmployees.getEmployees(this.busqueda)
        this.listadoEmpleados = response.data
      } catch (error) {
        this.listadoEmpleados = []
        this.tokenExpired = error?.response?.data?.tokenExpired || false
      }
    },
    async saveEmployee() {
      try {
        const response = await serviceEmployees.registerEmployee(
          this.noEmpleado,
          this.nombreEmpleado,
          this.rolEmpleado
        )
        if (response.error === false) {
          this.getEmployees()
          document.getElementById('btn-close').click()
          this.cleanNewEmployeeForm()
        } else this.apiError = response.msg
      } catch (error) {
        this.tokenExpired = error?.response?.data?.tokenExpired || false
        this.apiError =
          error.response.data.msg || 'Ocurrió un error al registrar al empleado, intente de nuevo.'
      }
    },
    async getRoles() {
      try {
        this.listaRoles = await serviceRoles.getRoles()
      } catch (error) {
        this.tokenExpired = error?.response?.data?.tokenExpired || false
        console.log(error)
      }
    },
    cleanError() {
      this.apiError = ''
    },
    cleanNewEmployeeForm() {
      this.noEmpleado = ''
      this.nombreEmpleado = ''
      this.rolEmpleado = null
    },
    async updateEmployee() {
      try {
        const datos = {
          name: this.nombreEmpleadoEdit,
          noEmployee: this.noEmpleadoEdit,
          rolId: this.rolEmpleadoEdit
        }

        const response = await serviceEmployees.updateEmployee(this.idEmpleado, datos)

        if (response.error === false) {
          this.getEmployees()
          document.getElementById('cerrarEditar').click()
        } else this.apiError = response.msg
      } catch (error) {
        this.tokenExpired = error?.response?.data?.tokenExpired || false
        this.apiError =
          error.response.data.msg || 'Ocurrió un error al actualizar el empleado, intente de nuevo.'
      }
    },
    async showEditar(id) {
      try {
        const response = await serviceEmployees.getEmployees('', id)
        const { data, error } = response

        if (error === false) {
          this.idEmpleado = data.id
          this.nombreEmpleadoEdit = data.name
          this.rolEmpleadoEdit = data.rolid
          this.noEmpleadoEdit = data.noemployee
        } else this.apiError = data.msg
      } catch (error) {
        this.tokenExpired = error?.response?.data?.tokenExpired || false
        this.apiError =
          error.response.data.msg || 'Ocurrió un error al mostrar los empleados, intente de nuevo.'
      }
    },
    async logOut() {
      const sesionUsuario = useSesionUsuario()
      try {
        useSesionUsuario.cerrarSesion()
        this.$router.push({ name: 'login' })
      } catch (error) {
        sesionUsuario.cerrarSesion()
        this.$router.push({ name: 'login' })
      }
    }
  }
}
</script>

<style scoped>
.contenedor-error {
  display: flex;
  justify-content: center;
  color: #f16a6a;
}
#formBuscarEmpleado {
  justify-content: flex-end !important;
  margin: 15px 0;
}
#buscarEmpleado {
  width: 304px !important;
}
.sin-contenido {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  min-height: 300px;
  text-align: center;
}

.filtro {
  width: 100%;
  display: flex;
  justify-content: flex-end;
  margin-bottom: 50px;
}

tr {
  cursor: pointer;
}
</style>
